function book_setup(ifmissing)
% book_setup()
% book_setup('warn')
% book_setup('error')
% book_setup('ignore')
%
narginchk(0, 1);
if nargin() < 1
    ifmissing = 'warn';
end

% Add the booklib path.
thisdir = fileparts(mfilename('fullpath'));
addpath([thisdir, '/booklib']);

% Bug in dasrt octave version 4.2.1
if isOctave() && isequal(version(), '4.2.1')
    dasrt_path = [thisdir, '/booklib/dasrt_v4_2_1.oct'];
    if exist(dasrt_path, 'file')
        autoload('dasrt', dasrt_path);
    else
        warning(['dasrt is bugged in Octave 4.2. ', ...
                 'Scripts calling dasrt may fail.']);
    end
end

% Issue errors, warnings, etc.
switch ifmissing
case 'error'
    missing = @error;
case 'warn'
    missing = @warning;
case 'ignore'
    missing = @(varargin) [];
otherwise
    error('Invalid argument!');
end

end%function

