% the complicated planar dynamics figure()
% jbr, 9/25/2011

% axes and (trace)^2 = 4 det line

x = linspace(-5,5,101)';
y = x.*x/4;
quad = [x, y];
lines = [-5, 0, 0, -7,   0, -1.5; ...
          5, 0, 0, -2.5, 0,   10];

% stable spiral
T = -0.2;
D = (T^2+4)/4;
A = [0, sqrt(D); -sqrt(D), T];
nts = 101;
time = linspace(0,15,nts)';
x0 = [1;1];
x = zeros(2,nts);
for  i = 1:length(time);
  x(:,i) = expm(A*time(i))*x0;
endfor
xssp = x';

function retval = setarrow(s, nrow, skip, x)
% print out gnuplot arrow commands
narrows = size(x,2)/2;
printf ("gnuplot arrow command -- %s\n", s)
for i = 1:narrows
  cols = (2*i-1):(2*i);
  arrowloc = [x(nrow,cols)', x(nrow+skip,cols)'];
  size = norm(arrowloc(:,1)-arrowloc(:,2));
% extend size of line so arrowhead is not clipped off by gnuplot
  arrowloc = arrowloc*[2, 0; -1, 1];
  arrowloc = arrowloc(:);
  printf ("set arrow %i from %g, %g to %g, %g filled size first %g, 15 lw 0\n", ...
           i, arrowloc, size)
endfor
endfunction

% put an arrow on the phase plot at the 11th point;
% size of arrow is adjusted by value of scale
nrow = 11;
s = "stable spiral";
% skip = 4;
% setarrow(s, nrow, skip, xssp)
s
xssp(nrow,:)


% unstable sprial; reverse time
%T = 0.2;
%D = (T^2+4)/4;
%A = [0, sqrt(D); -sqrt(D), T];
%x0 = [0.1;0.1];
x0 = [-1; -1];
x = zeros(2,nts);
for  i = 1:length(time);
  x(:,i) = expm(A*time(i))*x0;
endfor
xusp = x';
xusp = flipud(xusp);
% put an arrow on the phase plot 10 points from the end
nrow = size(xusp,1) - 10;
s = "unstable spiral";
% skip = 4;
% setarrow(s, nrow, skip, xusp);
s
xusp(nrow,:)


% stable node
% T = -1 + -0.5;
% D = (-1)*(-0.5);
A = [-0.5, 0; 0, -0.25];
x0 = [1;1];
x = zeros(2,nts);
for  i = 1:length(time);
  x(:,i) = expm(A*time(i))*x0;
endfor
x = x';
x1 = x(:,1); x2 = x(:,2);
xsno = [x, -x1, x2, -x1, -x2, x1, -x2];
% put an arrow on the phase plot at the 10th point of each IC (four of them)
nrow = 20;
s = "stable node";
%setarrow(s, nrow, skip, xsno);
s
xsno(nrow,:)

% reverse arrow direction for unstable node
nrow = 20;
s = "unstable node";
%setarrow(s, nrow, -skip, xsno);
s
xsno(nrow,:)


% unstable saddle, trace < 0
A = [-0.3, 0; 0, 0.2];
x0 = [-1;0.1];
x = zeros(2,nts);
for  i = 1:length(time);
  x(:,i) = expm(A*time(i))*x0;
endfor
x = x';
x1 = x(:,1); x2 = x(:,2);
xusa = [x, -x1, x2, -x1, -x2, x1, -x2];
% put an arrow on the phase plot at the 10th point of each IC (four of them)
nrow = 50;
%skip = 30;
s = "unstable saddle";
%setarrow(s, nrow, skip, xusa);
s
xusa(nrow,:)


% another unstable saddle, trace>0
A = [-0.1, 0; 0, 0.15];
x0 = [-1;0.1];
x = zeros(2,nts);
for  i = 1:length(time);
  x(:,i) = expm(A*time(i))*x0;
endfor
x = x';
x1 = x(:,1); x2 = x(:,2);
xusat = [x, -x1, x2, -x1, -x2, x1, -x2];
%skip = 40;
nrow = 75;
s = "unstable saddle; trace > 0";
%setarrow(s, nrow, skip, xusat);
s
xusat(nrow,:)


save "jimphase.dat" quad lines xssp xusp xsno xusa xusat